SystemOrganization addCategory: #ConfigurationOfKEGGeneratorBase!

Object subclass: #ConfigurationOfKEGGeneratorBase
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfKEGGeneratorBase'!

!ConfigurationOfKEGGeneratorBase commentStamp: '<historical>' prior: 0!
A ConfigurationOfKEGGeneratorBase is used to load and install the KEGGenerator related Classes and Methods into Pharo 2.0 Smalltalk.  See below for the Smalltalk code lines that you can evaluate in order to load and install the two main code variants.  Without tests and with tests.

	The KEGGenerator Classes provide KEGGenerators from the book A Little Smalltalk
	ftp://ftp.cs.orst.edu/pub/budd/little/ReadMe.html by Timothy A. Budd, 
	budd@cs.orst.edu Oregon State University style Generator stuff for
	the KEG Smalltalk software & software codes.
	Copyright (C) 1999  Kjell E God

	This Class is licensed as MIT Open Source.  Please evaluate ( Object licenseMIT ) for more info
	or see KEGLicense class>>licenseMIT.
	
See the web page at http://ss3.gemstone.com/ss/KEGGenerators.html/Overview.  If that page no longer exists then The main documentation is in the KEGGeneratorBasePackageComment Class comment and in the KEGGenerator Class comment and in the KEGOnableGenerator Class comment. Also the public Methods in the KEGGenerator Class all have long comments. There are 131 TestCase(s) which you can find in the test runner by looking for the KEGTestCaseObject Class and selecting all of its subClasses to run the tests. These tests are designed to show lots of examples of how to get the basic functionality of each generator Method to work. They show basic one line examples of each Method but they don`t really give a flavor of how KEGGenerators are used in practice.  For that we need an example project that uses KEGGenerators to do something.  But we don't have that yet.  It exists in Dolphin Smalltalk but not in Pharo yet.

You can evaluate the following lines of code to load and install various parts of the KEGGenerator codes.

To install the KEGGenerator and its supporting Classes and loose Methods evaluate: 
( ( ConfigurationOfKEGGeneratorBase project version: '1.0' ) load )"<---[ tested ]"
or
( ( ConfigurationOfKEGGeneratorBase project version: '1.0' ) load: 'default' )"<---[ not tested ]"
or
( ( ConfigurationOfKEGGeneratorBase project version: '1.0' ) load: 'Core' )"<---[ not tested ]"
or
( ( ConfigurationOfKEGGeneratorBase project version: '1.0' ) load: 'CompleteWithoutTests' )"<---[ not tested ]"
which should all be equivalent to each other.

To install the KEGGenerator and its supporting Classes and all the tests of most of those Methods evaluate:
( ( ConfigurationOfKEGGeneratorBase project version: '1.0' ) load: 'Tests' )"<---[ tested ]"
or
( ( ConfigurationOfKEGGeneratorBase project version: '1.0' ) load: 'CompleteWithTests' )"<---[ not tested ]"
which should be equivalent to each other.

There are other ways that you can load the Classes using >>load: but they have a high chance of not working right.  So I would stick to the cases listed above.!

!ConfigurationOfKEGGeneratorBase class methodsFor: 'development support' stamp: 'KjellGodo 10/28/2012 21:29'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfKEGGeneratorBase class methodsFor: 'private' stamp: 'KjellGodo 10/28/2012 21:29'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfKEGGeneratorBase class methodsFor: 'private' stamp: 'KjellGodo 10/28/2012 21:29'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfKEGGeneratorBase class methodsFor: 'private' stamp: 'KjellGodo 10/28/2012 21:29'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfKEGGeneratorBase class methodsFor: 'metacello tool support' stamp: 'KjellGodo 10/28/2012 21:29'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfKEGGeneratorBase class methodsFor: 'loading' stamp: 'KjellGodo 10/28/2012 21:29'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfKEGGeneratorBase class methodsFor: 'loading' stamp: 'KjellGodo 10/28/2012 21:29'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfKEGGeneratorBase class methodsFor: 'loading' stamp: 'KjellGodo 10/28/2012 21:29'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfKEGGeneratorBase class methodsFor: 'accessing' stamp: 'KjellGodo 10/28/2012 21:29'!
project

	^self new project! !

!ConfigurationOfKEGGeneratorBase class methodsFor: 'development support' stamp: 'KjellGodo 10/28/2012 21:29'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfKEGGeneratorBase methodsFor: 'as yet unclassified' stamp: 'KjellGodo 5/4/2013 16:13'!
baseline01: spec
	<version: '0.1-baseline'>
	spec for: #common do: [
		spec blessing: #stable.
		spec repository: 'http://ss3.gemstone.com/ss/KEGGenerators'.
		( spec project: 'KEGGeneratorBaseProject' with:[ 
				spec
					className: 'ConfigurationOfKEGGeneratorBase' ;
					versionString: #'stable' ;
					repository: 'http://ss3.gemstone.com/ss/KEGGenerators' ] ).
		spec
			package: 'KEGGeneratorBase' with: [
				spec requires: #( 'KEGPreModuleBase' 'KEGParameter' 'KEGUtilityStuff' 'KEGStreamUtilityStuff' ) ;
					includes: #( 'KEGGeneratorPost001FakeNew' ) ];
			package: 'KEGGeneratorBaseTest' with: [
				spec requires: #( 'KEGGeneratorBase' 'KEGUtilityStuffTest' ) ];
			package: 'KEGGeneratorPost001FakeNewTest' with: [
				spec requires: #( 'KEGGeneratorBaseTest' ) ];
			package: 'KEGUtilityStuffTest' with: [
				spec requires: #( 'KEGSystemTestClasses' 'KEGUtilityStuff' ) ];
			"<-------------------------------------------------------------------------------------------------[  ]"
			package: 'KEGGeneratorBase' with:[ spec repository: 'http://ss3.gemstone.com/ss/KEGGenerators' ];
			package: 'KEGGeneratorBaseTest' with:[ spec repository: 'http://ss3.gemstone.com/ss/KEGGenerators' ];
			package: 'KEGGeneratorPost001FakeNewTest' with:[ spec repository: 'http://ss3.gemstone.com/ss/KEGGenerators' ];
			package: 'KEGPreModuleBase' with:[ spec repository: 'http://ss3.gemstone.com/ss/KEGPreModuleBase' ];
			package: 'KEGParameter' with:[ spec repository: 'http://ss3.gemstone.com/ss/KEGParameter' ];
			package: 'KEGUtilityStuff' with:[ spec repository: 'http://ss3.gemstone.com/ss/KEGUtilityStuff' ]; 
			package: 'KEGUtilityStuffTest' with:[ spec repository: 'http://ss3.gemstone.com/ss/KEGUtilityStuff' ]; 
			package: 'KEGStreamUtilityStuff' with:[ spec repository: 'http://ss3.gemstone.com/ss/KEGUtilityStuff' ]; 
			package: 'KEGSystemTestClasses' with:[ spec repository: 'http://ss3.gemstone.com/ss/KEGUtilityStuff' ]; 
			package: 'KEGGeneratorPost001FakeNew' with:[ 
				spec repository: 'http://ss3.gemstone.com/ss/KEGGenerators' ] .
		spec
			group: 'default' with: #('KEGGeneratorBase' );
			group: 'Core' with: #('KEGGeneratorBase');
			group: 'Tests' with: #('KEGGeneratorPost001FakeNewTest');
			group: 'CompleteWithoutTests' with: #('Core');
			group: 'CompleteWithTests' with: #('CompleteWithoutTests' 'Tests') ].
		! !

!ConfigurationOfKEGGeneratorBase methodsFor: 'accessing' stamp: 'KjellGodo 10/28/2012 21:29'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfKEGGeneratorBase methodsFor: 'as yet unclassified' stamp: 'KjellGodo 4/27/2013 20:40'!
version01: spec 
	<version: '0.1' imports: #('0.1-baseline')>
	
	spec for: #common do: [
		spec 
			package: 'KEGGeneratorBase' with: 'KEGGeneratorBase-KjellGodo.9' ;
			package: 'KEGGeneratorBaseTest' with: 'KEGGeneratorBaseTest-KjellGodo.6' ;
			package: 'KEGGeneratorPost001FakeNew' with: 'KEGGeneratorPost001FakeNew-KjellGodo.4' ;
			package: 'KEGGeneratorPost001FakeNewTest' with: 'KEGGeneratorPost001FakeNewTest-KjellGodo.2' ;
			package: 'KEGPreModuleBase' with: 'KEGPreModuleBase-KjellGodo.1' ;
			package: 'KEGParameter' with: 'KEGParameter-KjellGodo.3' ;
			package: 'KEGUtilityStuff' with: 'KEGUtilityStuff-KjellGodo.8' ;
			package: 'KEGStreamUtilityStuff' with: 'KEGStreamUtilityStuff-KjellGodo.2' ;
			package: 'KEGUtilityStuffTest' with: 'KEGUtilityStuffTest-KjellGodo.3' ;
			package: 'KEGSystemTestClasses' with: 'KEGSystemTestClasses-KjellGodo.2' ].

! !

!ConfigurationOfKEGGeneratorBase methodsFor: 'as yet unclassified' stamp: 'KjellGodo 5/4/2013 09:49'!
version10: spec 
	<version: '1.0' imports: #('0.1-baseline')>
	
	spec for: #common do: [
		spec 
			package: 'KEGGeneratorBase' with: 'KEGGeneratorBase-KjellGodo.10' ;
			package: 'KEGGeneratorBaseTest' with: 'KEGGeneratorBaseTest-KjellGodo.7' ;
			package: 'KEGGeneratorPost001FakeNew' with: 'KEGGeneratorPost001FakeNew-KjellGodo.4' ;
			package: 'KEGGeneratorPost001FakeNewTest' with: 'KEGGeneratorPost001FakeNewTest-KjellGodo.2' ;
			package: 'KEGPreModuleBase' with: 'KEGPreModuleBase-KjellGodo.1' ;
			package: 'KEGParameter' with: 'KEGParameter-KjellGodo.3' ;
			package: 'KEGUtilityStuff' with: 'KEGUtilityStuff-KjellGodo.8' ;
			package: 'KEGStreamUtilityStuff' with: 'KEGStreamUtilityStuff-KjellGodo.2' ;
			package: 'KEGUtilityStuffTest' with: 'KEGUtilityStuffTest-KjellGodo.3' ;
			package: 'KEGSystemTestClasses' with: 'KEGSystemTestClasses-KjellGodo.2' ].

! !
